stages:
  - build-apache
  - build-php
  - build-wordpress
  - .post

variables:
  APACHE_VERSION: "2.4"
  PHP_VERSION_5: "5.6"
  PHP_VERSION_7: "7.4"
  PHP_VERSION_8: "8.3"
  KANIKO_VERSION: v1.23.2-debug

apache-base:
  stage: build-apache
  image:
    name: registry.gitlab.com/jhmdocker/image/kaniko:$KANIKO_VERSION
    pull_policy: always
  script:
    - |-
      /usr/local/bin/gitlab-auth
      /opt/kaniko/executor --context apache-base \
            --destination ${CI_REGISTRY_IMAGE} \
            --destination ${CI_REGISTRY_IMAGE}:${APACHE_VERSION} \
            --build-arg APACHE_VERSION=${APACHE_VERSION}

##################################################

apache-php5:
  needs: ["apache-base"]
  stage: build-php
  image:
    name: registry.gitlab.com/jhmdocker/image/kaniko:$KANIKO_VERSION
    pull_policy: always
  script:
    - |-
      /usr/local/bin/gitlab-auth
      /opt/kaniko/executor --context apache-php \
            --destination ${CI_REGISTRY_IMAGE}:php${PHP_VERSION_5} \
            --build-arg APACHE_VERSION=${APACHE_VERSION} \
            --build-arg PHP_VERSION=${PHP_VERSION_5}

apache-php7:
  needs: ["apache-base"]
  stage: build-php
  image:
    name: registry.gitlab.com/jhmdocker/image/kaniko:$KANIKO_VERSION
    pull_policy: always
  script:
    - |-
      /usr/local/bin/gitlab-auth
      /opt/kaniko/executor --context apache-php \
            --destination ${CI_REGISTRY_IMAGE}:php${PHP_VERSION_7} \
            --build-arg APACHE_VERSION=${APACHE_VERSION} \
            --build-arg PHP_VERSION=${PHP_VERSION_7}

apache-php8:
  needs: ["apache-base"]
  stage: build-php
  image:
    name: registry.gitlab.com/jhmdocker/image/kaniko:$KANIKO_VERSION
    pull_policy: always
  script:
    - |-
      /usr/local/bin/gitlab-auth
      /opt/kaniko/executor --context apache-php \
            --destination ${CI_REGISTRY_IMAGE}:php${PHP_VERSION_8} \
            --build-arg APACHE_VERSION=${APACHE_VERSION} \
            --build-arg PHP_VERSION=${PHP_VERSION_8}

##################################################

apache-wp5:
  needs: ["apache-php5"]
  stage: build-wordpress
  image:
    name: registry.gitlab.com/jhmdocker/image/kaniko:$KANIKO_VERSION
    pull_policy: always
  script:
    - |-
      /usr/local/bin/gitlab-auth
      /opt/kaniko/executor --context apache-wp \
            --destination ${CI_REGISTRY_IMAGE}:wp-php${PHP_VERSION_5} \
            --build-arg APACHE_VERSION=${APACHE_VERSION} \
            --build-arg PHP_VERSION=${PHP_VERSION_5}

apache-wp7:
  needs: ["apache-php7"]
  stage: build-wordpress
  image:
    name: registry.gitlab.com/jhmdocker/image/kaniko:$KANIKO_VERSION
    pull_policy: always
  script:
    - |-
      /usr/local/bin/gitlab-auth
      /opt/kaniko/executor --context apache-wp \
            --destination ${CI_REGISTRY_IMAGE}:wp-php${PHP_VERSION_7} \
            --build-arg APACHE_VERSION=${APACHE_VERSION} \
            --build-arg PHP_VERSION=${PHP_VERSION_7}

apache-wp8:
  needs: ["apache-php8"]
  stage: build-wordpress
  image:
    name: registry.gitlab.com/jhmdocker/image/kaniko:$KANIKO_VERSION
    pull_policy: always
  script:
    - |-
      /usr/local/bin/gitlab-auth
      /opt/kaniko/executor --context apache-wp \
            --destination ${CI_REGISTRY_IMAGE}:wp-php${PHP_VERSION_8} \
            --build-arg APACHE_VERSION=${APACHE_VERSION} \
            --build-arg PHP_VERSION=${PHP_VERSION_8}

Build webdav:
  stage: .post
  trigger:
    project: jhmdocker/image/webdav

# restart:
#  stage: post
#  image: bitnami/kubectl:latest
#  environment: vmi
#  script: |
#    kubectl config get-contexts
#    kubectl config use-context jhmdocker/k8s-agent-vmi:vmi01
#    kubectl rollout restart -n kohler     deploy/kohler
#    kubectl rollout restart -n hilger     deploy/hilger
#    #kubectl rollout restart -n multitude  deploy/multitude
